<?php
 /*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2014 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class xt_pro_import_fields_mapping {
	
	protected $_table = TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING;
	protected $_table_lang = null;
	protected $_table_seo = null;
	protected $_master_key = 'id';
	
	function setPosition ($position) {
		$this->position = $position;
	}
	
	function _getParams() {
		
		$params = array();
		
		if ($_GET['save_all']==true)
		{
			$this->UpdateGrid();
		}
		
		$header['id'] 					= array('type' => 'hidden');
		$header['proimportplugin_id'] 	= array('type' => 'hidden');
		$header['store_field'] 			= array('type' => 'dropdown','url'  => 'DropdownData.php?get=get_supported_fields_for_type&plugin_code=xt_pro_import&ei_type_spec=' . $this->url_data['ei_type_spec']);
		
		switch ($this->url_data['ei_type']) {
			case 'import':
				$header['csv_field'] 	= array('type' => 'dropdown','url'  => 'DropdownData.php?get=csv_columns&plugin_code=xt_pro_import&id=' . urlencode($this->url_data['proimportplugin_id']));
				//$header['sort_order'] 	= array('type' => 'hidden');
				break;
			// export
			default:
				$header['csv_field'] 	= array('type' => 'textfield');
				//$header['sort_order'] 	= array('type' => 'textfield');
				break;
		}
		
		$params['header']         = $header;
		$params['master_key']     = $this->_master_key;
		if ($this->url_data['ei_type'] == 'export') {
			$params['default_sort']   = 'sort_order';
			$params['SortField']      = 'sort_order';
		} else {
			$params['default_sort']   = $this->_master_key;
			$params['SortField']      = $this->_master_key;
		}
		$params['SortDir']        = "ASC";
		
		if (!$this->url_data['edit_id'] && $this->url_data['new'] != true) {
			$show = array ('id', 'store_field', 'csv_field');
			//if ($this->url_data['ei_type'] == 'export')
				$show[] = 'sort_order';
			
			$params['include'] = $show;
		}
		
		$params['exclude'] = array('setting_price_incl_tax', 'setting_show_full_path', 'setting_show_name');
		
		$rowActions[] = array('iconCls' => 'settings', 'qtipIndex' => 'qtip1', 'tooltip' => TEXT_XT_PRO_IMPORT_FIELD_SETTINGS);
		if ($this->url_data['edit_id'])
			$js = "var edit_id = ".$this->url_data['edit_id']."; \n";
		else
			$js = "var edit_id = record.id; \n";
		
		$qParams = array();
		
		$copy = $_GET;
		$copy['type'] = 'xt_pro_import_fields_settings';
		$copy['load_section'] = 'xt_pro_import_fields_settings';
		
		if (!isset($copy['edit_id'])) {
			$copy['edit_id'] = "'+ edit_id +'";
		}
		
		foreach ($copy as $key => $value) {
			$qParams[] = $key . '=' . $value;
		}
		
		$extF = new ExtFunctions();
		$js.= $extF->_RemoteWindow("TEXT_PRODUCTS_TO_MORE_CATEGORIES","TEXT_XT_PRO_IMPORT_FIELD_SETTINGS", "adminHandler.php?" . join('&', $qParams) . "", '', array(), 800, 600).' new_window.show();';
		
		$rowActionsFunctions['settings'] = $js;
		
		$params['rowActions']             = $rowActions;
		$params['rowActionsFunctions']    = $rowActionsFunctions;
		$params['gridType'] = 'EditGrid';
		$params['display_saveBtn'] = true;
		$params['display_editBtn']  = false;
		$params['PageSize'] = 1000;
		
		return $params;
	}
	
	function _get($ID = 0) {
		global $xtPlugin, $db, $language;
		
		if ($this->position != 'admin') return false;
	
		if ($ID === 'new') {
			$obj = $this->_set(array('proimportplugin_id' => $this->url_data['proimportplugin_id'], 'store_field' => '', 'csv_field' => ''), 'new');
			$ID = $obj->new_id;
		}
		
		$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key, 'proimportplugin_id="' . $this->url_data['proimportplugin_id'] . '"');
		
		if ($this->url_data['get_data'])
			$data = $table_data->getData();
		elseif($ID) {
			$data = $table_data->getData($ID);
		}
		else
			$data = $table_data->getHeader();
		
		$obj = new stdClass;
		$obj->totalCount = count($data);
		$obj->data = $data;
	
		return $obj;
	}
	
	function _set($data, $set_type='edit'){
		global $db,$language,$filter;
	
		$obj = new stdClass;
		if (empty($data['store_field'])) {
			$data['store_field'] = 'No selection';
		}
		if (empty($data['csv_field'])) {
			$data['csv_field'] = 'No selection';
		}
		$o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
		$obj = $o->saveDataSet();
			
		return $obj;
	}
	
	
	function _unset($id = 0) {
		global $db;
		if ($id == 0) return false;
		if ($this->position != 'admin') return false;
		$id=(int)$id;
		if (!is_int($id)) return false;
	
		$db->Execute("DELETE FROM ". $this->_table ." WHERE ".$this->_master_key." = '".$id."'");
	
	}
	
	function UpdateGrid() { 
		global $db;
		$data = array();
		
		$_totalEditCount = $_POST['_totalEditCount'];
		$edit_data =$_POST['edit_data'];
		$arr = explode("_next_##",$edit_data);
		foreach($arr as $r) {
			$new_ar = explode('##_key_##', $r);
			
			foreach($new_ar as $n_ar)
			{
				if ($n_ar!='')
				{
					$sss = explode('##_val_##', $n_ar);
					$data[$sss[0]] = $sss[1];
						
		
				}
			}
				
			if ($data['id']!='')
			{
				$res = $this->_set($data);
			} else {
				$obj = $this->_get('new');
				$data['id'] = $obj->data[0]['id'];
				$res = $this->_set($data);
			}
		}
	}
}

?>